/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.fel.pjv.cv11;

/**
 * Globalne dostupna trida, existuje nejvyse jedna - na zacatku programu
 * neexistuje a vzniknbe pri prvnim pouziti
 *
 * @author martin
 */
public final class Singleton3 {

    //volatile - necachovat tuto hodnotu
    private static volatile Singleton3 sing = null;
    private int data;

    public int getData() {
        return data;
    }

    public void setData(int data) {
        this.data = data;
    }

    /**
     * pouzivame pro pristup k existujici instanci pri prvnim pouziti vznikne
     * instance singletonu
     *
     * lazy instantiation - toto je threadsafe
     *
     * @return
     */
    public static Singleton3 getInstance() {
        //double checked locking:
        if (sing == null) {
            synchronized (Singleton3.class) {
                if (sing == null) {
                    sing = new Singleton3();
                }
            }
        }
        return sing;
    }

    private Singleton3() {
        data = 1024;
    }

}
